#include "stdafx.h"
#include <Themis/String/StringBuilder.h>

void StringBuilderTest() {
    StringBuilder builder1(L"ق");
    BOOST_CHECK(builder1.ToString() == L"ق");
    BOOST_CHECK(builder1.ToString(1, 1) == L"");
    BOOST_CHECK(builder1.ToString(2, 0) == L"");
    BOOST_CHECK(builder1.ToString(0, 1) == L"");

    builder1.Append(true); BOOST_CHECK(builder1.ToString(builder1.GetLength() - 4, 4) == L"True");
    builder1.Append(-999); BOOST_CHECK(builder1.ToString(builder1.GetLength() - 4, 4) == L"-999");
    builder1.Append(L""); BOOST_CHECK(builder1.ToString(builder1.GetLength() - 1, 1) == L"");
    builder1.Append(string(L"")); BOOST_CHECK(builder1.ToString(builder1.GetLength() - 1, 1) == L"");
 // VC++̃oOH(L`)
 // builder1.Append(""); BOOST_CHECK(builder1.ToString(builder1.GetLength() - 1, 1) == L"");
}
