#pragma once
#include <ctype.h>
namespace Themis {

#ifndef isblank

    inline bool iswblank(wchar_t c) {
        return c == L' ' || c == L'\t';
    }

#endif

/**
 * <ctype.h> ɑȂ̂ƂKɁB
 */
class CChar : private boost::noncopyable {
public:
    /// Shift_JIŜQoCĝPڂȂtrueԂ
    static inline bool Is2Byte(char c) {
        unsigned b = static_cast<unsigned char>(c);
        bool t = ((b ^ 0x20u) - 0xa1u) <= 0x3bu;
        Themis_DebugAssert(t == ((0x81u <= b && b <= 0x9fu) || (0xe0u <= b && b <= 0xfcu)));
        return t;
    }
    /// PoCgȂPAQoCgȂQԂ
    static inline int GetByteCount(char c) {
        return static_cast<int>(Is2Byte(c)) + 1;
    }

    /// 0`7Ȃ̂
    static inline bool IsOct(wchar_t c) { return L'0' <= c && c <= L'7'; }
    /// 0or1Ȃ̂
    static inline bool IsBin(wchar_t c) { return c == L'0' || c == L'1'; }
    /// pEEA_[XRAȂ̂
    static inline bool IsCSymbol(wchar_t c) { return iswalnum(c) || c == L'_'; }
    /// pA_[XRAȂ̂
    static inline bool IsCSymbolFirst(wchar_t c) { return iswalpha(c) || c == L'_'; }
};


}
