namespace Themis {

CDdb::CDdb(const CSize& sz) : CDC(InnerCreate(sz)) {
}

CDdb::~CDdb() {
    if (GetHandle() != NULL) {
        if (m_hBmp != NULL) {
            ::SelectObject(GetHandle(), m_hBmpOld);
            ::DeleteObject(m_hBmp);
            m_hBmp = NULL;
        }
        ::DeleteDC(GetHandle());
    }
}

CSize CDdb::GetSize() const {
    if (GetHandle() != NULL) {
        HBITMAP hBmp = static_cast<HBITMAP>(::GetCurrentObject(GetHandle(), OBJ_BITMAP));
        if (hBmp != NULL) {
            BITMAP oBmp;
            if (sizeof(oBmp) == ::GetObject(hBmp, sizeof(oBmp), &oBmp)) {
                if (1 < oBmp.bmWidth && 1 < oBmp.bmHeight) { //  ̂ȐԂ[ȁBB
                    return CSize(abs(oBmp.bmWidth), abs(oBmp.bmHeight));
                }
            }
        }
    }
    throw RuntimeException(L"rbg}bv̑傫擾o܂ł");
}

HDC CDdb::InnerCreate(const CSize& sz) {
    HDC hdcTmp = ::GetDC(NULL);
    HDC hdc = ::CreateCompatibleDC(hdcTmp);
    if (hdc == NULL) {
        ::ReleaseDC(NULL, hdcTmp);
        throw Win32Exception(L"摜ێ̍쐬Ɏs");
    }
    int w = (sz.cx + 3) & ~3;
 // m_hBmp = ::CreateCompatibleBitmap(hdc, w, sz.cy); // Rƕςۂ
    m_hBmp = ::CreateCompatibleBitmap(hdcTmp, w, sz.cy);
    ::ReleaseDC(NULL, hdcTmp);
    if (m_hBmp == NULL) {
        ::DeleteDC(hdc);
        throw Win32Exception(L"摜ێ̍쐬Ɏs");
    }
    //foCXReLXgDDBA^b`
    m_hBmpOld = (HBITMAP)::SelectObject(hdc, m_hBmp);
    return hdc;
}

}
