/** @file
 * KɁB
 *
 * CChoosePrinterŃv^I΂āA
 * CPrintDCŕ`揈B
 *
 * @author aki.
 */
#pragma once
#include "../../ImplData.h"
#include "DC.h"
namespace Themis {

/// RXgN^̈C肵̂ō\̂ɂĂ܂B
struct SPrintDCParam {
    HDC     hdc;            // v^HDCBCreateDCȂCChoosePrinterȂŁB
    string  strDocName;     // hLgBKOKH
    SPrintDCParam() {}
};

/**
    摜Ȃǂ̏ݐB

    StretchBltƂ͎gȂꍇȂ̂ŁA̕ӂ͒ӂׂB

    ̒~́A_CAOŃ{^ꂽ肵 SetAbort() āA
    ŁA IsAborted()  Abort() Ăяo悤ɂB
*/
class CPrintDC : public CDC {
public:
    CPrintDC(const SPrintDCParam& rParam);
    ~CPrintDC();

    /// y[WJn
    void StartPage();
    /// y[WI
    void EndPage();

    /// ͈͂̃sNZ̎擾
    CSize GetPixelSize() const;
    /// ͈͂̇_b̎擾(܂肠ĂɂȂȂH)
    CSize GetMilliMeterSize() const;
    /// pTCỸsNZ̎擾
    CSize GetPhysicalPixelSize() const;
    /// p̍Ə㑤̃}[W̃sNZ̎擾
    CRect GetPhysicalMarginPixelSize() const;
    /// ~Pʂŗp[̃}[Ww肵A`悷ׂW(sNZP)ԂB̒lBlt()ƂgOKB
    CRect GetMarginedPixelRect(int nL, int nR, int nT, int nB);

    /// fB
    void SetAbort();
    /// SetAbort() Ătrue
    bool IsAborted() const { return m_bAborted; }
    /// ̒f
    void Abort();

    /** StartPage() / EndPage()IɍsB

        RsypTv
    @code

        CPrintDC oPrintDC(...);
        for (int i = 0; i < nPage; i++) {
            CPrintDC::CPageLock oLock(oPrintDC);

            //oPrintDC֕`揈
        }

    @endcode

    */
    class CPageLock {
    public:
        CPageLock(CPrintDC& rDC) : m_rDC(rDC) { m_rDC.StartPage(); }
        ~CPageLock() { m_rDC.EndPage(); }
    private:
       CPrintDC&    m_rDC;
    };

private:
    bool    m_bAborted;
};


struct SChoosePrinterData;
/**
    v^IEwƂ̃_CAOB

    RsypTv
@code

        CChoosePrinter m_oChoosePrinter;
        m_oChoosePrinter.SetOwner(m_pWindow->GetHandle());
        m_oChoosePrinter.SetPageRange(1, 1);
        m_oChoosePrinter.SetDefaultPage(1, 1)
        if (m_oChoosePrinter.Show()) {

         // gĈB

            HDC hdc = m_oChoosePrinter.GetDC();
            pair<int, int> oPages = m_oChoosePrinter.GetPages();
        }

@endcode

*/
class CChoosePrinter {
    ImplData<SChoosePrinterData> data;
public:
    CChoosePrinter();
    ~CChoosePrinter();

    /// I[i[EBhE̐ݒ
    void SetOwner(HWND hWnd);
    /// y[W͈̔͂w
    void SetPageRange(int nMin, int nMax);
    /// y[W͈͎w𖳌ɂ
    void DisablePageRange() { SetPageRange(0, 0); }
    /// ftHg̃y[Wݒ
    void SetDefaultPage(int nStart, int nEnd);

    /// LZꂽfalse
    bool Show();

    /// v^HDC擾
    HDC GetDC() const;
    /// y[W̎擾Bfirst < secondƂĂBtĂ̂񂾂납H
    pair<int, int> GetPages() const;

private:
    void FreeData();
};


}
