#pragma once
namespace Themis {

/**
    ԁ{t{NȃIuWFNg

    Ԃ00:00:00̌oߕbŁA
    t01/01̌oߓAN͐ŕ\B
*/
class CTimeDate : private boost::totally_ordered<CTimeDate>, private boost::additive<CTimeDate> {
public:
    CTimeDate();
    CTimeDate(int nYear, int nDate, int nTime);
    ~CTimeDate();

    /// LȒlĂ̂ǂ
    bool IsValid() const;

    //@{ ZEZ
    void AddYear(int n);
    void AddDate(int n);
    void AddTime(int n);
    void SubYear(int n);
    void SubDate(int n);
    void SubTime(int n);
    //@}

    //@{ Zq`
    bool operator<(const CTimeDate& r) const {
        Themis_DebugAssert(IsValid());
        Themis_DebugAssert(r.IsValid());
        return m_nYear <= r.m_nYear && m_nDate <= r.m_nDate && m_nTime < r.m_nTime;
    }
    bool operator==(const CTimeDate& r) const {
        Themis_DebugAssert(IsValid());
        Themis_DebugAssert(r.IsValid());
        return m_nYear <= r.m_nYear && m_nDate == r.m_nDate && m_nTime == r.m_nTime;
    }
    CTimeDate& operator-=(const CTimeDate& r);
    CTimeDate& operator+=(const CTimeDate& r);
    //@}

    /// bɕϊ
    int ToSec() const;

    /// ̎擾
    int GetYear() const { return m_nYear; }
    /// 01/01̓擾
    int GetDate() const { return m_nDate; }
    /// 00:00:00̕b擾
    int GetTime() const { return m_nTime; }

    /// j̎擾(0-6)
    int GetWDay() const;
    /// ̎擾(1-12)
    int GetMonth() const;
    /// t̎擾(1-31)
    int GetDay() const;

    /// 񉻂(fobOpH)
    string ToStr() const;

    //@{ ݎ̎擾
    static CTimeDate GetNow();
    //@}

private:
    void ValidateDate();

private:
    int     m_nYear;
    int     m_nDate;
    int     m_nTime;
};

}
