/** @file
 * ֘ÅȒPȊ֐ƂB
 * @author aki.
 */
#pragma once
namespace Themis {

//@{ lƕ̑ݕϊ
string ItoA(int i);
string FtoA(double d);
int AtoI(const string& str);
double AtoF(const string& str);
//@}

//@{ char[]Ȃǂւ̃̕Rs[Bobt@I[o[Ȃ悤ɒӂB
void StrCopy(char* psz, size_t length, const string& src);
inline void StrCopy(wchar_t* psz, size_t length, const string& str) {
    Themis_DebugAssert(0 < length);
    if (str.GetLength() + 1 <= static_cast<int>(length)) {
        memcpy(psz, str.ToCharPtr(), (str.GetLength() + 1) * sizeof(wchar_t));
    } else {
        memcpy(psz, str.ToCharPtr(), (length - 2) * sizeof(wchar_t));
        psz[length - 1] = L'\0';
    }
}
//@}

/// string -> char[]̕ϊBdelete[]KvȂ̂ŒӁB
char* ToMultiByteChars(const string& str);

//@{ FXϊBCEncodeĝʓ|܂ŕKvȂƎv̂ŁBB
string BinToHex(const vector<uint8_t>& vctBin);
string BinToBase64(const vector<uint8_t>& vctBin);
vector<uint8_t> HexToBin(const string& strHex);
vector<uint8_t> Base64ToBin(const string& strBase64);
//@}

//@{ ܂Ƃ߂Ēu
string Replace(const string& str, vector<pair<string, string> >& vct);
string Replace(const string& str, vector<pair<wchar_t, wchar_t> >& vct);
//@}

/// puts̃ChłĖ񂩂ˁH
inline void wputs(const wchar_t* p) { wprintf(L"%s\n", p); }
/// ܂B
inline void wputs(const string& str) { wputs(str.ToCharPtr()); }

}
