#pragma once
namespace Themis {

/**
    std::mapۂvectorB

    vfȂƂ͖{ǂA
    CfbNXANZXo肷̂_̂B
*/
template<class K, class T> class map_vector {
private:
    typedef map_vector<K, T> this_type;

public:
    typedef typename K key_type;
    typedef typename T data_type;
    typedef pair<key_type, data_type> value_type;
    typedef typename data_type& reference;
    typedef typename const data_type& const_reference;
    typedef typename vector<value_type>::size_type size_type;
    typedef typename vector<value_type>::iterator iterator;
    typedef typename vector<value_type>::const_iterator const_iterator;

    typedef typename boost::call_traits<key_type>::param_type key_param;
    typedef typename boost::call_traits<data_type>::param_type data_param;

    map_vector() {}
    ~map_vector() {}

    template<class Cmp> inline iterator find(key_param k, Cmp less) {
        for (size_t i = 0, n = m_vct.size(); i < n; i++) {
            if (less(m_vct[i].first, k)) {
            } else if (less(k, m_vct[i].first)) {
                break;
            } else {
                // 
                return m_vct.begin() + i;
            }
        }
        // Ȃ
        return m_vct.end();
    }
    inline iterator find(key_param k) {
        return find(k, std::less<key_type>());
    }

    template<class Cmp> inline const_iterator find(key_param k, Cmp less) const {
        return const_cast<this_type*>(this)->find(k, less);
    }
    inline const_iterator find(key_param k) const {
        return find(k, std::less<key_type>());
    }

    template<class Cmp> inline pair<bool, iterator> insert(key_param k, data_param t, Cmp less) {
        for (size_t i = 0, n = m_vct.size(); i < n; i++) {
            if (less(m_vct[i].first, k)) {
            } else if (less(k, m_vct[i].first)) {
                // ǉďI
                m_vct.insert(m_vct.begin() + i, value_type(k, t));
                return make_pair(true, m_vct.begin() + i);
            } else {
                // ɑ݂
                return make_pair(false, m_vct.begin() + i);
            }
        }
        // ǉďI
        m_vct.push_back(value_type(k, t));
        return make_pair(true, m_vct.begin() + m_vct.size() - 1);
    }
    inline pair<bool, iterator> insert(key_param k, data_param t) {
        return insert(k, t, std::less<key_type>());
    }

    template<class Cmp> inline void erase(key_param k, Cmp less) {
        for (size_t i = 0, n = m_vct.size(); i < n; i++) {
            if (less(m_vct[i].first, k)) {
            } else if (less(k, m_vct[i].first)) {
                // ݂Ȃ
                break;
            } else {
                // 폜ďI
                m_vct.erase(m_vct.begin() + i);
                break;
            }
        }
    }
    inline void erase(key_param k) { erase(k, std::less<key_type>()); }

    inline reference operator[](key_param k) {
        return (*insert(k, data_type()).second).second;
    }
    inline data_param operator[](key_param k) const { // ߂lconst_reference̕H
        const_iterator it = find(k);
        return it == end() ? _get_empty() : (*it).second;
    }

    inline void clear() { m_vct.clear(); }
    inline bool empty() const { return m_vct.empty(); }
    inline size_type size() const { return m_vct.size(); }
    inline iterator begin() { return m_vct.begin(); }
    inline iterator end() { return m_vct.end(); }
    inline const_iterator begin() const { return m_vct.begin(); }
    inline const_iterator end() const { return m_vct.end(); }

    //@{ vectorIȂƂB
    inline iterator erase(iterator it) { return m_vct.erase(it); }
    inline iterator erase(iterator f, iterator l) { return m_vct.erase(f, l); }
    inline void pop_front() { m_vct.pop_front(); }
    inline void pop_back() { m_vct.pop_back(); }
    inline value_type& operator[](size_type n) { return m_vct[n]; }
    inline const value_type& operator[](size_type n) const { return m_vct[n]; }
    inline void reserve(size_type n) { m_vct.reserve(n); }
    //@}

private:
    struct _tmp_data {
        data_type _data;
        _tmp_data() : _data() {}
    };
    static data_param _get_empty() {
        static _tmp_data s_data;
        return s_data._data;
    }

private:
    vector<value_type> m_vct;
};

}
