#pragma once
#include "Stream.h"
namespace Themis {

/**
    f[^kEÍȂǂ̋ʃC^[tF[XB

    kƈÍ܂Ƃ߂Ӗ͖ǁAǂC^[tF[X͑SȂ̂ŁBB
*/
class IEncoder : private boost::noncopyable {
public:
    virtual ~IEncoder() {}
    virtual void Encode(IWriteStream& rDstStream, const IReadStream& rSrcStream) = 0;
    virtual void Decode(IWriteStream& rDstStream, const IReadStream& rSrcStream) = 0;
};

/**
    LZSSkA
*/
class CLZSSCompress : public IEncoder {
public:
    CLZSSCompress();
    ~CLZSSCompress();

    void Encode(IWriteStream& rDstStream, const IReadStream& rSrcStream);
    void Decode(IWriteStream& rDstStream, const IReadStream& rSrcStream);

private:
    void InsertNode(int r);         // r؂ɑ}
    void DeleteNode(int p);         // p؂
    BOOST_STATIC_CONSTANT(int, RING_BUFSIZE = 4096);   //obt@̑傫
    BOOST_STATIC_CONSTANT(int, LONGEST_MATCH = 18);    //Œv
    BOOST_STATIC_CONSTANT(int, NIL = RING_BUFSIZE);    //؂̖[
    uint8_t m_abyText[RING_BUFSIZE + LONGEST_MATCH - 1];
    int m_dad[RING_BUFSIZE + 1];
    int m_lsn[RING_BUFSIZE + 1];
    int m_rsn[RING_BUFSIZE + 257];
    int m_matchpos, m_matchlen;     // Œvʒu, v
};

}
