#pragma once
#include "PriorityObject.h"
namespace Themis {

/**
    IuWFNg쐬IuWFNg̊NXB

    RgɂāAIuWFNgĎg
    ۃNXɍς܂鎖o悤ɂȂB
*/
template<class T> class IFactory : private boost::noncopyable {
public:
    virtual ~IFactory() {}
    virtual std::tr1::shared_ptr<T> CreateInstance() = 0;
};

/**
    TNX쐬Factory
*/
template<class T, class B = T> class DefaultFactory : public IFactory<B> {
public:
    virtual std::tr1::shared_ptr<B> CreateInstance() {
        return std::tr1::shared_ptr<B>(new T);
    }
};

/**
    IDlIuWFNg쐬IuWFNg̊NXB

    IDɑΉIuWFNgꍇNULLԂƂOƂAgŁB
*/
template<class T> class IParameterizedFactory : private boost::noncopyable {
public:
    virtual ~IParameterizedFactory() {}
    virtual std::tr1::shared_ptr<T> CreateInstance(int nId) = 0;
};


/**
    vector<PriorityObject<Factory<T> > > NXB

    RsypTv
@code

    for (int i = 0, n = oFactoryList.GetCount(); i < n; i++) {
        std::tr1::shared_ptr<T> pObject = oFactoryList.CreateInstance(i);
    }

@endcode

    Priority̏Ƀ\[gĂBPriorityƂOrderƂB
    ꍇ͌ォo^̂ɁB
*/
template<class T> class FactoryList : private boost::noncopyable {
    typedef IFactory<T> IFactory;
    typedef PriorityObject<IFactory> object;
public:
    FactoryList() {}
    ~FactoryList() {}

    /// o^ĂIFactory̍폜
    void Clear() { m_vct.clear(); }

    /// o^BnPriorityȗ0ƂB
    void Add(const std::tr1::shared_ptr<IFactory>& pFactory, int nPriority = 0) {
        size_t i = 0;
        for (size_t n = m_vct.size(); i < n; i++) {
            if (pFactory == m_vct[i].GetPtr()) {
                // ̂͗vȂ
                return;
            } else if (nPriority < m_vct[i].GetPriority()) {
                break;
            }
        }
        m_vct.insert(m_vct.begin() + i, object(pFactory, nPriority));
    }
    /// std::tr1::shared_ptrexplicitʓ|Ȃ̂ŁBB
    void Add(IFactory* p, int nPriority = 0) { Add(std::tr1::shared_ptr<IFactory>(p), nPriority); }
    /// o^
    void Add(const object& rFactory) {
        size_t i = 0;
        for (size_t n = m_vct.size(); i < n; i++) {
            if (rFactory.GetPtr() == m_vct[i].GetPtr()) {
                // ̂͗vȂ
                return;
            } else if (rFactory < m_vct[i]) {
                break;
            }
        }
        m_vct.insert(m_vct.begin() + i, rFactory);
    }

    /// o^ĂIFactory̍폜(Priorityw)
  /*
    void Remove(int nPriority) {
        m_vct.erase(std::remove(m_vct.begin(), m_vct.end(), nPriority), m_vct.end());
    }
  */
    /// o^ĂIFactory̍폜(|C^w)
    void Remove(IFactory* p) {
        for (size_t i = 0, n = m_vct.size(); i < n; i++) {
            if (p == m_vct[i].Get()) {
                m_vct.erase(m_vct.begin() + i);
                break;  //d͋ĂȂ̂łŏI
            }
        }
    }
    /// o^ĂIFactory̍폜(Priority͈͎w)
 // void Remove(int nPriorityMin, int nPriorityMax);

    /// IFactory̌̎擾
    int GetCount() const { return static_cast<int>(m_vct.size()); }

    /// T ̍쐬
    std::tr1::shared_ptr<T> CreateInstance(int i) const { return m_vct[i]->CreateInstance(); }

private:
    vector<object> m_vct;
};


}
