#pragma once
#include "Timer.h"
#include "Wnd.h"
namespace Themis {

/**
    RXgN^fXgN^܂ł̏ԂbZ[W{bNXŕ\B

    vt@CƂ{iIɂقǂł񂾂ǁc݂ȎɁB
    ȒPɃRsyďo悤ɁASCCŁB
*/
class CTimeChecker : private boost::noncopyable {
public:
    CTimeChecker(const string& str = L"IntervalTimeChecker"): m_strTitle(str) {
        CTimer::Begin();
        m_nStart = CTimer::Get();
    }
    ~CTimeChecker() {
        int nDiff = CTimer::Get() - m_nStart;
        CTimer::End();
        CWnd().MsgBox(m_strTitle, string::Format(L"%d [ms]", nDiff));
    }
private:
    unsigned    m_nStart;
    string      m_strTitle;
};


/**
    Wo͔ŁB

    boost::progress_timer @\IɂقړǁA
    timeBeginPeriod()gĂ̂ł̕x͂B
*/
class CTimeCheckerStdOut : private boost::noncopyable {
public:
    CTimeCheckerStdOut(const string& str): m_strTitle(str) {
        CTimer::Begin();
        m_nStart = CTimer::Get();
    }
    ~CTimeCheckerStdOut() {
        int nDiff = CTimer::Get() - m_nStart;
        CTimer::End();
        puts(Encoding::GetDefault().GetBytes(string::Format(L"%s : %d [ms]",
            m_strTitle.ToCharPtr(), nDiff)).c_str());
    }
private:
    unsigned m_nStart;
    string m_strTitle;
};

/**
    Themis_DebugAlwaysLog()
*/
class CTimeCheckerLog : private boost::noncopyable {
public:
    CTimeCheckerLog(const string& str): m_strTitle(str) {
        CTimer::Begin();
        m_nStart = CTimer::Get();
    }
    ~CTimeCheckerLog() {
        int nDiff = CTimer::Get() - m_nStart;
        CTimer::End();
        Themis_DebugAlwaysLog(string::Format(L"%s : %d [ms]", m_strTitle.ToCharPtr(), nDiff));
    }
private:
    unsigned    m_nStart;
    string      m_strTitle;
};

}
