/** @file
 * ŊĂȒPȊ֐ƂB
 *
 * @author aki.
 */
#pragma once
namespace Themis {

/// z̗vf擾BenumƂzƂɎgȂnamespaceԈă|C^g肵ȂŁB
template<class T, int N> inline int lengthof(T (& x)[N]) { return N; }

//@{ max, minBVC̓}NŒ`ĂƂʓ|Ȃ̂ŁBB
template<class T> inline T Min(T a, T b) { return a < b? a: b; }
template<class T> inline T Max(T a, T b) { return a < b? b: a; }
// I}PňRƂSB
template<class T> inline T Min(T a, T b, T c) { return Min(Min(a, b), c); }
template<class T> inline T Max(T a, T b, T c) { return Max(Max(a, b), c); }
template<class T> inline T Min(T a, T b, T c, T d) { return Min(Min(a, b), Min(c, d)); }
template<class T> inline T Max(T a, T b, T c, T d) { return Max(Max(a, b), Max(c, d)); }
//@}

/** zɈׂ̃CfbNXvZ
    @param i    CfbNXl
    @param c    z̗vf
*/
int GetRotatedIndex(int i, int c);
/// GetRotatedIndex()̃CNg
inline int GetRotatedIndexOnInc(int i, int c) {
    Themis_DebugAssert(0 <= i);
    Themis_DebugAssert(i <= c);
    return i < c? i: 0;
}
/// GetRotatedIndex()̃fNg
inline int GetRotatedIndexOnDec(int i, int c) {
    Themis_DebugAssert(-1 <= i);
    Themis_DebugAssert(i < c);
    return 0 <= i? i: c - 1;
}

//@{ <algorithm>Ȃ̊֐AVC++Ōx̂őւKɎB

template<class II, class OI> inline
OI std_copy(II in, II end, OI out) {
    for (; in != end; ++in, ++out)
        *out = *in;
    return out;
}


template<class II, class OI, class _Uop> inline
OI std_transform(II in, II end, OI out, _Uop _U) {
    for (; in != end; ++in, ++out)
        *out = _U(*in);
    return out;
}

template<class II1, class II2, class OI, class BOP> inline
OI std_transform(II1 in1, II1 end1, II2 in2, OI out, BOP b) {
    for (; in1 != end1; ++in1, ++in2, ++out)
        *out = b(*in1, *in2);
    return out;
}

template<class II, class OI, class T> inline
OI std_replace_copy(II in, II end, OI out, const T& vo, const T& vn) {
    for (; in != end; ++in, ++out)
        *out = *in == vo ? vn : *in;
    return out;
}

template<class II, class OI, class PR, class T> inline
OI std_replace_copy_if(II in, II end, OI out, PR pr, const T& t) {
    for (; in != end; ++in, ++out)
        *out = pr(*in) ? t : *in;
    return out;
}

//@}

}
